require 'active_support/inflector'

require 'marble_gate/authorizer'
require 'marble_gate/access'
require 'marble_gate/errors'

module MarbleGate
  module BaseMethods
    def authorize!(model = nil, *args)
      unless model
        raise MarbleGate::MissingModel unless respond_to?(:controller_name)
        model = controller_name.classify.constantize
      end
      raise MarbleGate::AccessDenied unless can?(params[:action], model, *args)
    end

    def can?(action, model, *args)
      # p "#{model.class.to_s}Authorizer".constantize
      MarbleGate.access(self, action, *args).for_model?(model)
    end

    def cannot?(action, model, *args)
      !can?(action, model, *args)
    end
  end
end
