require 'active_support/inflector'

require 'marble_gate/authorizer'
require 'marble_gate/access'
require 'marble_gate/errors'

module MarbleGate
  module ControllerClassMethods
    def authorize!(cls = nil, *args, only: [], except: [])
      cls = cls || controller_name.classify.constantize

      before_action(only: only, except: except) do
        res = MarbleGate.access(self, params[:action], *args).for_authorizer?(cls)
        raise MarbleGate::AccessDenied unless res
      end
    end
  end
end
