require 'marble_gate/base_methods'
require 'marble_gate/controller_class_methods'

module Dome
  class Railtie < Rails::Railtie
    initializer "action_view.initialize_marble_gate" do
      ActiveSupport.on_load(:action_view) do
        ActionView::Base.send :include, MarbleGate::BaseMethods
      end
      ActiveSupport.on_load(:action_controller) do
        ActionController::Base.send :include, MarbleGate::BaseMethods
        ActionController::Base.send :extend, MarbleGate::ControllerClassMethods
      end
    end
  end
end
